################################################################################
#
# MGBA
#
################################################################################

# Version of 22/08/2021
LIBRETRO_MGBA_VERSION = 50e0fe9972aa9f4ab34a10e6d451877f048e6fa7
LIBRETRO_MGBA_SITE = $(call github,mgba-emu,mgba,$(LIBRETRO_MGBA_VERSION))
LIBRETRO_MGBA_LICENSE = MPL-2.0
LIBRETRO_MGBA_LICENSE_FILES = LICENSE
#LIBRETRO_MGBA_DEPENDENCIES +=

ifeq ($(BR2_PACKAGE_HAS_LIBGL),y)
LIBRETRO_MGBA_DEPENDENCIES += libgl
endif

ifeq ($(BR2_PACKAGE_HAS_LIBGLES),y)
LIBRETRO_MGBA_DEPENDENCIES += libgles
endif

LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_C_ARCHIVE_CREATE="<CMAKE_AR> qcs <TARGET> <LINK_FLAGS> <OBJECTS>"
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_C_ARCHIVE_FINISH=true
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_CXX_ARCHIVE_CREATE="<CMAKE_AR> qcs <TARGET> <LINK_FLAGS> <OBJECTS>"
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_CXX_ARCHIVE_FINISH=true
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_AR="$(TARGET_CC)-ar"
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_C_COMPILER="$(TARGET_CC)"
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_CXX_COMPILER="$(TARGET_CXX)"
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_LINKER="$(TARGET_LD)"
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_C_FLAGS="$(COMPILER_COMMONS_CFLAGS_SO)"
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_CXX_FLAGS="$(COMPILER_COMMONS_CXXFLAGS_SO)"
LIBRETRO_MGBA_CONF_OPTS += -DCMAKE_EXE_LINKER_FLAGS="$(COMPILER_COMMONS_LDFLAGS_SO)"
# Options
LIBRETRO_MGBA_CONF_OPTS += -DUSE_DEBUGGERS=OFF
LIBRETRO_MGBA_CONF_OPTS += -DUSE_EDITLINE=OFF
LIBRETRO_MGBA_CONF_OPTS += -DUSE_GDB_STUB=OFF
LIBRETRO_MGBA_CONF_OPTS += -DUSE_FFMPEG=ON
LIBRETRO_MGBA_CONF_OPTS += -DUSE_ZLIB=ON
LIBRETRO_MGBA_CONF_OPTS += -DUSE_MINIZIP=ON
LIBRETRO_MGBA_CONF_OPTS += -DUSE_PNG=ON
LIBRETRO_MGBA_CONF_OPTS += -DUSE_LIBZIP=ON
LIBRETRO_MGBA_CONF_OPTS += -DUSE_SQLITE3=OFF
LIBRETRO_MGBA_CONF_OPTS += -DUSE_ELF=ON
LIBRETRO_MGBA_CONF_OPTS += -DM_CORE_GBA=ON
LIBRETRO_MGBA_CONF_OPTS += -DM_CORE_GB=ON
LIBRETRO_MGBA_CONF_OPTS += -DUSE_LZMA=ON
LIBRETRO_MGBA_CONF_OPTS += -DUSE_DISCORD_RPC=OFF
LIBRETRO_MGBA_CONF_OPTS += -DENABLE_SCRIPTING=ON
# Build
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_PERF=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_TEST=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_SUITE=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_CINEMA=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_ROM_TEST=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_EXAMPLE=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_PYTHON=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_STATIC=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_SHARED=ON
LIBRETRO_MGBA_CONF_OPTS += -DSKIP_LIBRARY=ON
LIBRETRO_MGBA_CONF_OPTS += -DUSE_EPOXY=ON
LIBRETRO_MGBA_CONF_OPTS += -DDISABLE_DEPS=OFF
LIBRETRO_MGBA_CONF_OPTS += -DDISTBUILD=OFF
# Frontends
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_QT=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_SDL=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_LIBRETRO=ON
# Backends
ifeq ($(BR2_PACKAGE_HAS_LIBGL),y)
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_GL=ON
else
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_GL=OFF
endif
ifeq ($(BR2_PACKAGE_HAS_LIBGLES),y)
ifeq ($(BR2_PACKAGE_RECALBOX_TARGET_RPI4)$(BR2_PACKAGE_RECALBOX_TARGET_RPI4_64)$(BR2_PACKAGE_RECALBOX_TARGET_ODROIDGO2),y)
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_GLES2=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_GLES3=ON
else
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_GLES2=ON
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_GLES3=OFF
endif
else
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_GLES2=OFF
LIBRETRO_MGBA_CONF_OPTS += -DBUILD_GLES3=OFF
endif

define LIBRETRO_MGBA_INSTALL_TARGET_CMDS
	$(INSTALL) -D $(@D)/mgba_libretro.so \
		$(TARGET_DIR)/usr/lib/libretro/mgba_libretro.so
endef

define LIBRETRO_MGBA_PRE_CONFIGURE
	$(SED) "s|platform/posix/|platform/libretro/|g" $(@D)/CMakeLists.txt
endef

LIBRETRO_MGBA_PRE_CONFIGURE_HOOKS += LIBRETRO_MGBA_PRE_CONFIGURE

$(eval $(cmake-package))
